<template>
  <div :class="`fancy-alert alert alert-${type}`" role="alert">
    <div class="fancy-alert__icon">
      <i :class="`${iconClassInternal} x2`"></i>
    </div>
    <div class="fancy-alert__message">
      <slot></slot>
    </div>
  </div>
</template>

<script>
import { computed } from 'vue'

export default {
  name: 'FancyAlert',
  props: {
    type: { type: String, default: 'primary' }, // primary|secondary|info|success|danger|warning|light|dark
    iconClass: { type: String, default: '' },
  },
  setup(props) {
    const iconClassInternal = computed(() => {
      if (props.iconClass) {
        return props.iconClass
      }

      switch (props.type) {
        case 'success':
          return 'bi bi-check-circle-fill'
        case 'danger':
          return 'bi bi-bug-fill'
        case 'warning':
          return 'bi bi-exclamation-triangle-fill'
        default:
          return 'bi bi-info-circle-fill' // primary|secondary|info|light|dark
      }
    })

    return {
      iconClassInternal,
    }
  },
}
</script>

<style lang="scss">
@use '../sass/vars';

.fancy-alert {
  display: flex;
  width: 100%;
}

.fancy-alert__icon {
  flex-grow: 0;
  padding-right: vars.$spacing;
}

.fancy-alert__message {
  flex-grow: 1;
}
</style>
